<?php
/*
Plugin Name: Add Email Post-login
Description: Adds email for logged-in users who have not entered any, eg OpenID logins
Author: Emily Ravenwood and Ken Irwin
Version: 1.0
Plugin URI: http://alltrees.org/wordpress/
Author URI: http://www.alltrees.org/
License: GPL v3 (http://www.gnu.org/copyleft/gpl.html)
*/

function add_missing_email() {
	
	//set all the variables we'll need
	global $wpdb;
	global $_POST;
	global $user_email, $user_ID;
	get_currentuserinfo();
	
	extract($_POST);
	extract($_SERVER);
	
	$this_file = "http://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	
	
	//if the form has been submitted, process it and mark that user as having email so the form doesn't show up again
	if ($given_email) {
		
		//escape the input just to be on the safe side
		$added_email = $wpdb->escape($given_email);
	
		$query = "UPDATE $wpdb->users SET user_email = '".$added_email."' WHERE ID = '".$given_user_ID."'";	
	
		if ( mysql_query ($query) ) {
			$user_email = $added_email;
		}// end if query submitted
	}// end if form submitted
	
	
	//if the user is logged in but does not have an email entered, show the form for entering one
	if ( '' != $user_ID ) {
		if ( ! $user_email ) {
		
			echo '
			<div id="email-form" style="border:6px red double; margin:1em; padding: .5em 1em;">
			<p>Your OpenID provider did not supply an email address for you.  Please enter one now.</p>
			<form action="'.$this_file.'#addcommentanchor" method="post" id="add_email_form">
			<input type="hidden" name="given_user_ID" value="'.$user_ID.'" />
			<div style="text-align:center;">
			<span>Email Address:</span> <input type="text" name="given_email" size="28" />
			<input type="submit" value="Submit" name="submit_add_email" />
			</div>
			</form>
			<p>Your email will never be made public; it will be stored securely and only you and the site admin will have access to it.</p>
			</div>
			';			
			
		}// end if no email
	}// end if logged in user
	
	
}//end function

?>